SET TERM ^ ;

/******************************************************************************/
/***                                 Tables                                 ***/
/******************************************************************************/

ALTER TABLE TBADDSUMM
ADD ADDINFO DMCOMMENT
COLLATE WIN1251^

/******************************************************************************/
/***                           Stored Procedures                            ***/
/******************************************************************************/

CREATE OR ALTER PROCEDURE WEB_TRANSFER_CASH(
    OPERNAME VARCHAR(128),
    SUMMIN DOUBLE PRECISION,
    ACCOUNTID INTEGER,
    EMITTERKCID INTEGER,
    TRANSFERTIME DATE,
    FLAGSIN INTEGER,
    ADDINFO VARCHAR(128),
    OPID INTEGER,
    CURRENCYIDIN INTEGER,
    ADDINDEX INTEGER,
    ACCOUNTIDOUT INTEGER)
RETURNS (
    TRANSFERSTATUS INTEGER,
    SUMMOUT DOUBLE PRECISION,
    CURRENCYID INTEGER,
    FLAGSOUT INTEGER)
AS
declare variable connections integer;
declare variable status integer;
declare variable transid integer;
declare variable summ double precision;
declare variable currencyidout integer;
BEGIN
  /* :
     flagsin = 0 -      
     flagsin = 1 -     
     flagsin = 2 -       
     flagsin = 3 -       
     flagsin = 4 -      
  */
  if(transfertime is null) then transfertime='now';
  SummOut=0;
  TransferStatus=0;
  flagsout=Null;

  if(flagsin=0 and summin>0) then /*       */
  begin
    SELECT Summ,Connections,Status
      FROM tbAccountsUpdate
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID)
      INTO :Summ,:CONNECTIONS,:Status;
    IF((SummIn>Summ) or (Summ<=0))  THEN BEGIN /*     */
      TransferStatus=-681;             /*??*/
      SUSPEND;
      EXCEPTION exBreak;
    END

    IF(CONNECTIONS>1) THEN BEGIN /*     ,    */
      TransferStatus=-684;
      SUSPEND;
      EXCEPTION exBreak;
    END

    IF((Status IS NULL) OR (Status IN (-9,-11,-13))) THEN BEGIN /*      */
      TransferStatus=-683;
      SUSPEND;
      EXCEPTION exBreak;
    END

    SELECT CurrencyID
      FROM  tbAccounts
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountIDout)
      INTO :CurrencyIDOut;
    IF(CurrencyIDOut IS NULL) THEN BEGIN /*    */
      TransferStatus=-682;             /*??*/
      SUSPEND;
      EXCEPTION exBreak;
    END

    SELECT CurrencyID
      FROM  tbAccounts
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID)
      INTO :CurrencyID;

    UPDATE tbAccountsUpdate
      SET SUMM=SUMM-:Summin
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID);

    TransID=GEN_ID(gnTransID,1);

    INSERT INTO tbAddSumm(AddDate,AddBy,Summ,CurrencyID,EmitterKCID,AccountID,OpID,TransID,AddInfo)
      VALUES(:TransferTime,:Opername,-:SummIn,:CurrencyID,:EmitterKCID,:AccountID,:OpID,:TransID,:AddInfo);

    SummOut=SummIn;

    EXECUTE PROCEDURE INT_CURRENCYTRANSFER(:SUMMIN,:CURRENCYID,:CURRENCYIDOUT)
      RETURNING_VALUES :SUMMIN;

    UPDATE tbAccountsUpdate
      SET SUMM=SUMM+:SummIn
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountIDout);

    INSERT INTO tbAddSumm(AddDate,AddBy,Summ,CurrencyID,EmitterKCID,AccountID,OpID,TransID,AddInfo)
      VALUES(:TransferTime,:Opername,:SummIn,:CurrencyIDout,:EmitterKCID,:AccountIDout,:OpID,:TransID,:AddInfo);
  end

  if(flagsin=1 and summin>0) then /*      */
  begin
    SELECT CurrencyID
      FROM  tbAccounts
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountIDout)
      INTO :CurrencyIDOut;
    IF(CurrencyIDOut IS NULL) THEN BEGIN /*    */
      TransferStatus=-682;               /*??*/
      SUSPEND;
      EXCEPTION exBreak;
    end

    EXECUTE PROCEDURE INT_CURRENCYTRANSFER(:SUMMIN,:CURRENCYIDIN,:CURRENCYIDOUT)
      RETURNING_VALUES :SUMMIN;
    SummOut=SummIn;

    UPDATE tbAccountsUpdate
      SET SUMM=SUMM+:SummIn
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountIDout);

    INSERT INTO tbAddSumm(AddDate,AddBy,Summ,CurrencyID,EmitterKCID,AccountID,OpID,TransID,AddInfo)
      VALUES(:TransferTime,:Opername,:SummIn,:CurrencyIDout,:EmitterKCID,:AccountIDout,:OpID,:TransID,:AddInfo);

  end

  if(flagsin=2 and summin>0) then /*      .   >> flagsout */
  begin
    SELECT Summ,Connections,Status
      FROM tbAccountsUpdate
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID)
      INTO :Summ,:CONNECTIONS,:Status;
    IF((SummIn>Summ) or (Summ<=0))  THEN BEGIN /*     */
      TransferStatus=-681;             /*??*/
      SUSPEND;
      EXCEPTION exBreak;
    END

    IF(CONNECTIONS>1) THEN BEGIN /*     ,    */
      TransferStatus=-684;
      SUSPEND;
      EXCEPTION exBreak;
    END

    IF((Status IS NULL) OR (Status IN (-9,-11,-13))) THEN BEGIN /*      */
      TransferStatus=-683;
      SUSPEND;
      EXCEPTION exBreak;
    END

    SELECT CurrencyID
      FROM  tbAccounts
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID)
      INTO :CurrencyID;

    UPDATE tbAccountsUpdate
      SET SUMM=SUMM-:Summin
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID);

    INSERT INTO tbAddSumm(AddDate,Addby,Summ,CurrencyID,EmitterKCID,AccountID,AddInfo)
      VALUES(:TransferTime,:Opername, -:SummIn,:CurrencyID,:EmitterKCID,:AccountID,:AddInfo);

      SummOut=SummIn;
      FlagsOut=gen_id(GNADDINDEX,0);
  end

  if(flagsin=3 and addindex>0 and summin>0) then /*        */
  begin
    select summ
      from tbAddSumm
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID) AND (ADDINDEX=:Addindex) and transid is null
      INTO :Summ;
    if(summ is null) then begin /*    */
      TransferStatus=-686;
      SUSPEND;
      EXCEPTION exBreak;
    end

    TransID=GEN_ID(gnTransID,1);
    update tbaddsumm
      set transid=:transid,addinfo=:addinfo
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID) AND (ADDINDEX=:Addindex);
  end

  if(flagsin=4 and addindex>0 and summin>0) then /*       */
  begin
    select summ
      from tbAddSumm
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID) AND (ADDINDEX=:Addindex) and transid is null
      INTO :Summ;
    if(summ is null) then begin /*    */
      TransferStatus=-686;
      SUSPEND;
      EXCEPTION exBreak;
    end

    TransID=GEN_ID(gnTransID,1);
    UPDATE tbAccountsUpdate
      SET SUMM=SUMM+:Summin
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID);

    update tbaddsumm
      set transid=:transid
      WHERE (EmitterKCID=:EmitterKCID) AND (AccountID=:AccountID) AND (ADDINDEX=:Addindex);

    INSERT INTO tbAddSumm(AddDate,AddBy,Summ,CurrencyID,EmitterKCID,AccountID,OpID,TransID,AddInfo)
      VALUES(:TransferTime,:opername,:SummIn,:CurrencyID,:EmitterKCID,:AccountID,:OpID,:TransID,:AddInfo);
  end

  SUSPEND;
  /*   */
  WHEN EXCEPTION exBreak DO
     TransferStatus = TransferStatus;
END^

SET TERM ; ^
