<?php
/**
 * Process.php
 */
require_once(dirname(__FILE__).'/include/session.php');
require_once(dirname(__FILE__).'/include/conn_stargazer.php');
require_once(dirname(__FILE__).'/include/conn_potok.php');

class Process
{
	function Process() {
		global $session, $logger;

		if(isset($_POST['substklogin']))
			$this->procSTKLogin();
		elseif(isset($_POST['subforgot']))
			$this->procForgotPass();
//		elseif(isset($_POST['subedit']))
//			$this->procEditAccount();
		elseif(isset($_POST['sub_stk_attributes'])) {
			$attr_action = $_POST['sub_stk_attributes'];
			if ($session->userlevel == ADMIN_LEVEL) {
				switch ($attr_action){
					case 1: $this->procSTKAttributes(); break;
					case 3: $this->ProcSTKOpBlockAccount(); break;
					case 5: $this->ProcSTKOpUnBlockAccount(); break;
					default:
						header("Location: ".$session->referrer);
				}
			} else {
				switch ($attr_action){
					case 3: $this->ProcSTKOpBlockAccount(); break;
					case 5: $this->ProcSTKOpUnBlockAccount(); break;
					default:
						header("Location: ".$session->referrer);
				}
			}
		}
		elseif(isset($_POST['sub_stk_notepad']))
			$this->procSTKNotePad();
		elseif(isset($_POST['sub_stk_mailboxes'])) {
			if ($session->userlevel == ADMIN_LEVEL)
				$this->procSTKMailBoxes();
			else
				header("Location: ".$session->referrer);
		}
		elseif(isset($_POST['sub_stk_pins'])) {
			if ($session->userlevel == ADMIN_LEVEL)
				$this->procSTKPINs();
			else
				header("Location: ".$session->referrer);
		}
		elseif(isset($_POST['sub_stk_operations'])) {
			if ($session->userlevel == ADMIN_LEVEL) {
				$act = $_POST['sub_stk_operations_action'];
				switch ($act) {
					case 1:
						$this->ProcSTKOpAddCash();
						break;
					case 2:
						$this->ProcSTKOpChangeGroup();
						break;
					case 3:
						$this->ProcSTKOpBlockAccount();
						break;
					case 4:
						$this->ProcSTKOpTimeBlockAccount();
						break;
					case 5:
						$this->ProcSTKOpUnBlockAccount();
						break;
					case 6:
						$this->ProcSTKOpActivateAccount();
						break;
					case 7:
						$this->ProcSTKOpDeactivateAccount();
						break;
					case 8:
						$this->ProcSTKOpFinishSessions();
						break;
					default:
						header("Location: ".$session->referrer);
				} //switch
			} else
				header("Location: ".$session->referrer);
		}
		elseif(isset($_POST['sub_stk_security']))
			$this->procSTKSecurity($_POST['sub_stk_security']);
		elseif (isset($_POST['sub_stk_transfer'])) {
			$logger->log("sub_stk_transfer=".print_r($_POST['sub_stk_transfer'], true));
			$dest = explode(":", $_POST['sub_stk_transfer']);
			switch ($dest[0]) {
				case 'stk':
					$this->procTransferCash();
					break;
				case 'stg':
					$this->procTransferCashStargazer();
					break;
				case 'pot_check':
					$this->procTransferCashPotok_CheckAccount();
					break;
				case 'pot_pay':
					$this->procTransferCashPotok_Pay($dest[1], $dest[2]);
					break;
				default:
					header("Location: ".$session->referrer);
			}  //switch
		}
		elseif(isset($_POST['sub_stk_cases']))
			$this->procCasesOperation($_POST['sub_stk_cases']);
		elseif(isset($_POST['sub_stk_reports']))
			$this->procReports($_POST['sub_stk_reports']);
		/**
		 * The only other reason user should be directed here
		 * is if he wants to logout, which means user is
		 * logged in currently.
		 */
		elseif($session->logged_in)
			$this->procLogout();
		/**
		 * Should not get here, which means user is viewing this page
		 * by mistake and therefore is redirected.
		 */
		else
			header("Location: main.php");
	}

	function procSTKLogin() {
		global $session, $form;

		$retval = $session->stklogin($_POST['accid'], $_POST['pin'], $_POST['checknumber']);
		if($retval){
			header("Location: ".$session->referrer);
		}
		/* Login failed */
		else{
			$_POST['pin'] = "";
			$_SESSION['value_array'] = $_POST;
			$_SESSION['error_array'] = $form->getErrorArray();
			header("Location: ".$session->referrer);
		}
	}

	/**
	 * procLogout - Simply attempts to log the user out of the system
	 * given that there is no logout form to process.
	 */
	function procLogout(){
		global $session;
		$session->logout();
		header("Location: main.php");
	}

	/**
	 * procForgotPass - Validates the given username then if
	 * everything is fine, a new password is generated and
	 * emailed to the address the user gave on sign up.
	 */
	function procForgotPass() {
		global $session;
		header("Location: ".$session->referrer);
	}

	function procSTKAttributes()	{
		global $stk_database, $session;

		$retval = true;
		$accid = $session->stk_accountid;
		$emtid = $session->stk_emitterkcid;
		if ($retval) {
			$maxconnections = $_POST["inp_stk_attr_maxconnections"];
			if ($maxconnections == "")
				$maxconnections= "null";
			$fio = $_POST["inp_stk_attr_fio"];
			$cur = $_POST["sel_stk_attr_cur"];
			$roum = $_POST["sel_stk_attr_roum"];
			$stk_database->query("Update tbAccounts set FIO='$fio',ROUMINGMODE=$roum,MAXCONNECTIONS=$maxconnections,CurrencyID=$cur where (EmitterKCID=$emtid) and (AccountID=$accid)");

			//TODO: check wtf in rinoAdmin
			//1 step: delete prev usrextacnt name (like rinoAdmin)
			//$stk_database->query("Delete from tbPersonalAccounts where (EmitterKCID=$emtid) and (AccountID=$accid)");
			//2 step: set new
			//$usrextaccount = trim($_POST["inp_stk_usrextaccount"]);
			//if ($usrextaccount!="" || $usrextaccount!="") {
			//   $stk_database->query("Insert into tbPersonalAccounts(PersonalAccount,EmitterKCID,AccountID) values($usrextaccount,$emtid,$usrid)");
			//}
			header("Location: ".$session->referrer);
		}
	}

	/*function procSTKNotePad() {
		global $stk_database, $session, $logger;

		$del_q = "delete from tbNotePad where (EmitterKCID=$session->stk_emitterkcid) and (AccountID=$session->stk_accountid)";
		$stk_database->query($del_q);
		$logger->log("procSTKNotePad:Delete Records=".print_r($del_q, true));

		$arrIDs = explode(",", trim($_POST['hidChangedNBNumberIDHolder'], ","));
		$logger->log("procSTKNotePad:arrIDs=".print_r($arrIDs, true));
		foreach ($arrIDs as $id) {
			//TODO: validate field values
			if ($id{0} != '-') {
				$q = sprintf("insert into tbNotePad (EmitterKCID,AccountID,RealNumber,NumberB) Values (%d,%d,'%s','%s')",
							$session->stk_emitterkcid,
							$session->stk_accountid,
							$_POST["nb_realnumber_$id"],
							$_POST["nb_numberb_$id"]
							);
				$logger->log("procSTKNotePad: Insert->".print_r($q, true));
				$stk_database->query($q);
			}
		}
		header("Location: ".$session->referrer);
	}*/

	function procSTKNotePad() {
		global $stk_database, $session, $logger;

		$arrIDs = explode(",", trim($_POST['hidChangedNBNumberIDHolder'], ","));
		$logger->log("procSTKNotePad:arrIDs=".print_r($arrIDs, true));
		foreach ($arrIDs as $id) {
			//TODO: validate field values
			if (is_numeric($id)) {
				if ($id[0] == '-')
					$stk_database->delNotebookRec($session->stk_accountid, $session->stk_emitterkcid, $_POST["nb_realnumber_orig_".abs($id)]);
				else
					$stk_database->addNotebookRec($session->stk_accountid, $session->stk_emitterkcid,
								$_POST["nb_realnumber_$id"], $_POST["nb_numberb_$id"], $_POST["nb_addinfo_$id"]);
			}
		}
		header("Location: ".$session->referrer);
	}

	function procSTKMailBoxes() {
		global $stk_database, $session, $logger;
		//delete prev
		//   $del_q = "Delete from tbBoxes where (EmitterKCID=$session->stk_emitterkcid) and (AccountID=$session->stk_accountid)";
		//   $stk_database->query($del_q);
		//   $logger->log("procSTKMailBoxes:Delete Records=".print_r($del_q, true));
		//
		$arrIDs = explode(",", trim($_POST['hidChangedMBNumberIDHolder'], ","));
		$logger->log("procSTKMailBoxes:arrIDs=".print_r($arrIDs, true));
		foreach ($arrIDs as $id) {
			//TODO: validate field values
			if (eregi("^(-?)([0-9])+$",$id)) {
				if ($id[0] != '-') {
					$q = sprintf("Insert into tbBoxes(BOXCOMMONID,EMITTERKCID,ACCOUNTID,BOXTYPEID,MAXSIZE) values('%s',%d,%s,%d,%s)",
								$_POST["mb_public_$id"],
								$session->stk_emitterkcid,$session->stk_accountid,
								$_POST["stk_mb_id_$id"],$_POST["mb_size_$id"]);
					$logger->log("procSTKMailBoxes: Insert->".print_r($q, true));
					$stk_database->query($q);
				} else {
					$abs_id = abs($id);
					$del_q = sprintf("Delete from tbBoxes where (EmitterKCID=%d) and (AccountID=%s) and (BoxCommonID=%s)",
					$session->stk_emitterkcid,$session->stk_accountid,$_POST["mb_public_$abs_id"]);
					//$del_q = "Delete from tbBoxes where (EmitterKCID=$session->stk_emitterkcid) and (AccountID=$session->stk_accountid)";
					//$del_q .= " and (BOXCOMMONID='".$_POST["mb_public_$id"]."')";
					$stk_database->query($del_q);
					$logger->log("procSTKMailBoxes:Delete Records=".print_r($del_q, true));
				}
			}
		}
		header("Location: ".$session->referrer);
	}

	function procSTKPINs() {
		global $stk_database, $session, $logger;
		//get ownerkcid
		///$acc_info = $stk_database->getSTKInfo($session->stk_accountid,$session->stk_emitterkcid);
		///$ownerkcid = $acc_info["OWNERKCID"];
		//PINs: 1-del prev; 2- ins new
		//      $del_q = "Delete from tbPins where (EmitterKCID=$session->stk_emitterkcid) and (AccountID=$session->stk_accountid)";
		//      $stk_database->query($del_q);
		//      $logger->log("procSTKPinsPin:Delete Records=".print_r($del_q, true));
		//
		//
		$arrIDs = explode(",", trim($_POST['hidChangedPinsPINIDHolder'], ","));
		$logger->log("procSTKPinsPin:arrIDs=".print_r($arrIDs, true));
		foreach ($arrIDs as $id) {
			//TODO: validate field values
			if ($id[0] != '-') {
				$q = sprintf("Update tbPins set AccountID=%s,EmitterKCID=%d where (Pin='%s')",
				$session->stk_accountid,$session->stk_emitterkcid,
				$_POST["pins_pin_$id"]);
				$logger->log("procSTKPINsPin: Update->".print_r($q, true));
				$stk_database->query($q);
			} else {
				$abs_id = abs($id);
				$d_q = sprintf("Update tbPins set AccountID=NULL,EmitterKCID=%d where (Pin='%s')",
				$session->stk_emitterkcid,$_POST["pins_pin_$abs_id"]);
				$logger->log("procSTKPINsPin: Update".print_r($d_q, true));
				$stk_database->query($d_q);
			}
		}
		//NUMs: 1-del prev; 2- ins new
		//      $del_q = "Delete from tbPinPhones where (EmitterKCID=$session->stk_emitterkcid) and (AccountID=$session->stk_accountid)";
		//      $stk_database->query($del_q);
		//      $logger->log("procSTKPinsNum:Delete Records=".print_r($del_q, true));
		//
		//
		$arrIDs = explode(",", trim($_POST['hidChangedPinsNumberIDHolder'], ","));
		$logger->log("procSTKPinsNum:arrIDs=".print_r($arrIDs, true));
		foreach ($arrIDs as $id) {
			//TODO: validate field values
			if ($id[0] != '-') {
				$q = sprintf("Insert into tbPinPhones (PINPHONE,EMITTERKCID,ACCOUNTID) values('%s',%d,%d)",
				$_POST["pins_num_$id"],
				$session->stk_emitterkcid,$session->stk_accountid);
				$logger->log("procSTKPINsNum: Insert->".print_r($q, true));
				$stk_database->query($q);
			} else {
				$abs_id = abs($id);
				$d_q = sprintf("Delete from tbPinPhones where (PinPhone='%s')",$_POST["pins_num_$id"]);
				$logger->log("procSTKPINsNum: Update".print_r($d_q, true));
				$stk_database->query($d_q);
			}
		}
		//
		header("Location: ".$session->referrer);
	}

	function ProcSTKOpAddCash() {
		global $stk_database, $session, $logger;

		$summ = $_POST["inp_stk_op_add"];
		$q = "execute procedure int_addSumm($session->stk_emitterkcid,$session->stk_accountid,$summ)";
		$stk_database->query($q);
		$logger->log("ProcSTKOpAddCash:".print_r($q, true));
		header("Location: ".$session->referrer);
	}

	function ProcSTKOpChangeGroup() {
		global $stk_database, $session, $logger;

		$gr = $_POST["sel_stk_op_acc"];
		$q = "Update tbAccounts set ACCOUNTGROUPID=$gr where (EmitterKCID=$session->stk_emitterkcid) and (AccountID=$session->stk_accountid)";
		$stk_database->query($q);
		$logger->log("ProcSTKOpChangeGroup():".print_r($q, true));
		header("Location: ".$session->referrer);
	}

	function SetSTKOpAccountStatus($sts) {
		global $stk_database, $session, $logger;

		$q = "Update tbAccountsUpdate set STATUS=$sts where (EmitterKCID=$session->stk_emitterkcid) and (AccountID=$session->stk_accountid)";
		$stk_database->query($q);
		$logger->log("SetSTKOpAccountStatus($sts):".print_r($q, true));
		return true;
	}

	function ProcSTKOpBlockAccount() {
		global $session;

		$block_status = -2;
		$this->SetSTKOpAccountStatus($block_status);
		header("Location: ".$session->referrer);
	}

	function ProcSTKOpUnBlockAccount() {
		global $session;

		$block_status = 0;
		$this->SetSTKOpAccountStatus($block_status);
		header("Location: ".$session->referrer);
	}

	function ProcSTKOpActivateAccount() {
		global $session;

		$block_status = 0;
		$this->SetSTKOpAccountStatus($block_status);
		header("Location: ".$session->referrer);
	}

	function ProcSTKOpDeactivateAccount() {
		global $session;

		header("Location: ".$session->referrer);
	}

	function ProcSTKOpTimeBlockAccount() {
		global $session;

		$block_status = -13;
		$this->SetSTKOpAccountStatus($block_status);
		header("Location: ".$session->referrer);
	}

	function ProcSTKOpFinishSessions() {
		global $stk_database, $session, $logger;

		$q = "Select * From int_VoluntaryClose($session->stk_accountid,$session->stk_emitterkcid)";
		$stk_database->query($q);
		$logger->log("ProcSTKOpFinishSessions():".print_r($q, true));
		header("Location: ".$session->referrer);
	}

	function procSTKSecurity($secop) {
		global $stk_database, $session, $logger;

		$logger->log("procSTKSecurity($secop):".print_r($_POST, true));

		switch ($secop) {
			case 'sec_block':
				$block_status = -2;
				$this->SetSTKOpAccountStatus($block_status);
				break;
			case 'sec_unblock':
				$block_status = 0;
				$this->SetSTKOpAccountStatus($block_status);
				break;
			default:
				//security Status
				$status = $_POST['stk_sec_op'];
				$q = "Update tbAccounts set SecurityStatus=$status where (EmitterKCID=$session->stk_emitterkcid) AND (AccountID=$session->stk_accountid)";
				$stk_database->query($q);
				$logger->log("ProcSTKSecurity_Status():".print_r($q, true));

				$arrIDs = explode(",", trim($_POST['hidChangedSecNumberIDHolder'], ","));
				$logger->log("procSTKSecurity:arrIDs=".print_r($arrIDs, true));
				foreach ($arrIDs as $id) {
					//TODO: validate field values
					if ($id[0] != '-') {
						$q = sprintf("Insert into TBSECURITYPHONES(SecurityNumber,EMITTERKCID,ACCOUNTID,AdditionalInfo) values('%s',%d,%s,'%s')",
						$_POST["sec_number_$id"],
						$session->stk_emitterkcid,$session->stk_accountid,
						$_POST["sec_info_$id"]);
						$logger->log("procSTKSecurity: Insert->".print_r($q, true));
						$stk_database->query($q);
					} else {
						$abs_id = abs($id);
						$d_q = sprintf("Delete From tbSecurityPhones where (EmitterKCID=%d) and (AccountID=%s) and (SecurityNumber='%s')",
						$session->stk_emitterkcid,$session->stk_accountid,
						$_POST["sec_number_$abs_id"]);
						$stk_database->query($d_q);
						$logger->log("ProcSTKSecurity_Delete():".print_r($d_q, true));
					}
				}
		}

		header("Location: ".$session->referrer);
	}

	function procTransferCash() {
		global $form, $stk_database, $session;

		$transfer_summ = $_POST['transfer_summ'];
		$field = 'transfer_summ';
		if (!$transfer_summ || strlen($transfer_summ = trim($transfer_summ)) == 0)
			$form->setError($field, '*     ');

		$transfer_dest_acc = $_POST['transfer_dest_stk_acc'];
		$field = 'transfer_dest_stk_acc';
		if (!$transfer_dest_acc || strlen($transfer_dest_acc = trim($transfer_dest_acc)) == 0)
			$form->setError($field, '*     ');

		if ($form->num_errors > 0) {
			$_SESSION['value_array'] = $_POST;
			$_SESSION['error_array'] = $form->getErrorArray();
		} else {
			$_SESSION['transfer_done'] = false;

			$tc_result = $stk_database->transferCashEx($transfer_summ,
														$session->stk_accountid,
														$session->stk_emitterkcid,
														"     (" .
														"  $session->stk_accountid, " .
														" " . $session->stk_accountinfoex['FIO'] . ")",
														$transfer_dest_acc,
														$session->stk_accountcurrencyid);
			if (is_array($tc_result)) {
				$_SESSION['transfer_done'] = true;
				$_SESSION['transfer_result_code'] = $tc_result['TRANSFERSTATUS'];
				$_SESSION['transfer_result_summ'] = $tc_result['SUMMOUT'];
				$_SESSION['transfer_result_currencyid'] = $tc_result['CURRENCYID'];
			}
		}

		header("Location: ".$session->referrer);
	}

	function procTransferCashStargazer() {
		global $form, $stk_database, $session, $conn_stargazer;

		$transfer_summ = $_POST['transfer_summ'];
		$field = 'transfer_summ';
		if (!$transfer_summ || strlen($transfer_summ = trim($transfer_summ)) == 0)
			$form->setError($field, '*     ');

		$transfer_dest_acc = $_POST['transfer_dest_stg_acc'];
		$field = 'transfer_dest_stg_acc';
		if (!$transfer_dest_acc || strlen($transfer_dest_acc = trim($transfer_dest_acc)) == 0)
			$form->setError($field, '*     -');

		if ($form->num_errors > 0) {
			$_SESSION['value_array'] = $_POST;
			$_SESSION['error_array'] = $form->getErrorArray();
		} else {
			$_SESSION['transfer_done'] = false;

			$transact = 0;
			$addinfo_stk = "    - (  $transfer_dest_acc)";
			$addinfo_stg = "    ( $session->stk_accountid,  " . $session->stk_accountinfoex['FIO'] . ")";
			$tc_result = $stk_database->transferCashExternal('start',
															$transfer_summ,
															$session->stk_accountid,
															$session->stk_emitterkcid,
															$addinfo_stk);
			if (is_array($tc_result)) {
				$_SESSION['transfer_done'] = true;
				$_SESSION['transfer_result_code'] = $tc_result['TRANSFERSTATUS'];
				$_SESSION['transfer_result_summ'] = $tc_result['SUMMOUT'];
				$_SESSION['transfer_result_currencyid'] = $tc_result['CURRENCYID'];

				if ($_SESSION['transfer_result_code'] === 0) {
					$transact = $tc_result['FLAGSOUT'];

					$external_res = $conn_stargazer->sg_cash_add($transfer_dest_acc, $transfer_summ, $addinfo_stg);

					$mode = $external_res === true ? 'commit' : 'rollback';
					$addinfo_stk .= $external_res === true ? '.  .' : '.  .';
					$tc_result = $stk_database->transferCashExternal($mode,
																	$transfer_summ,
																	$session->stk_accountid,
																	$session->stk_emitterkcid,
																	$addinfo_stk,
																	$transact);
					if (is_array($tc_result))
						$_SESSION['transfer_result_code'] = $tc_result['TRANSFERSTATUS'];
					if ($external_res === false)
						$_SESSION['transfer_result_code'] = -9999;
				}
			}
		}

		header("Location: ".$session->referrer);
	}

	function procTransferCashPotok_CheckAccount() {
		global $form, $session, $conn_potok;

		unset($_SESSION['transfer_done']);
		unset($_SESSION['transfer_data_avail']);
		unset($_SESSION['transfer_data']);

		$transfer_dest_acc = is_numeric($_POST['transfer_dest_pot_acc']) ? $_POST['transfer_dest_pot_acc'] : null;
		$transfer_dest_number = is_numeric($_POST['transfer_dest_pot_number']) ? $_POST['transfer_dest_pot_number'] : null;
		$transfer_dest_dogovor = (strlen($_POST['transfer_dest_pot_dogovor']) > 0) ? $_POST['transfer_dest_pot_dogovor'] : null;
		$field = 'transfer_dest_pot_number';
		if (!$transfer_dest_acc && !$transfer_dest_number && !$transfer_dest_dogovor &&
			strlen($transfer_dest_acc.$transfer_dest_number.$transfer_dest_dogovor) == 0)
			$form->setError($field, '*        ');

		$_SESSION['value_array'] = $_POST;
		if ($form->num_errors > 0) {
			$_SESSION['error_array'] = $form->getErrorArray();
		} else {
			$tc_result = $conn_potok->getAccountInfo($transfer_dest_acc, $transfer_dest_number, $transfer_dest_dogovor);
			if (is_array($tc_result)) {
				$_SESSION['transfer_data_avail'] = true;
				$_SESSION['transfer_data'] = $tc_result;
			}
		}

		header("Location: ".$session->referrer);
	}

	function procTransferCashPotok_Pay($importid, $accountid) {
		global $form, $stk_database, $session, $conn_potok;

		$transfer_summ = $_POST['transfer_summ'];
		$field = 'transfer_summ';
		if (!$transfer_summ || strlen($transfer_summ = trim($transfer_summ)) == 0)
			$form->setError($field, '*     ');

		$_SESSION['value_array'] = $_POST;
		if ($form->num_errors > 0) {
			$_SESSION['error_array'] = $form->getErrorArray();
		} else {
			unset($_SESSION['transfer_data_avail']);
			unset($_SESSION['transfer_data']);

			$_SESSION['transfer_done'] = false;
			$_SESSION['value_array'] = $_POST;

			$transact = 0;
			$addinfo_stk = "          (importid=$importid)";
			$tc_result = $stk_database->transferCashExternal('start',
															$transfer_summ,
															$session->stk_accountid,
															$session->stk_emitterkcid,
															$addinfo_stk);
			if (is_array($tc_result)) {
				$_SESSION['transfer_done'] = true;
				$_SESSION['transfer_result_code'] = $tc_result['TRANSFERSTATUS'];
				$_SESSION['transfer_result_summ'] = $tc_result['SUMMOUT'];
				$_SESSION['transfer_result_currencyid'] = $tc_result['CURRENCYID'];

				if ($_SESSION['transfer_result_code'] === 0) {
					$transact = $tc_result['FLAGSOUT'];

					$external_res = $conn_potok->updateAccountInfo($accountid, $transfer_summ, $importid);

					$mode = is_array($external_res) && ($external_res['flagout'] > 0) ? 'commit' : 'rollback';
					$addinfo_stk .= $mode === 'commit' ? '.  .' : '.  .';
					$_SESSION['transfer_result_summ'] = $transfer_summ;
					$tc_result = $stk_database->transferCashExternal($mode,
																	$transfer_summ,
																	$session->stk_accountid,
																	$session->stk_emitterkcid,
																	$addinfo_stk,
																	$transact);
					if (is_array($tc_result))
						$_SESSION['transfer_result_code'] = $tc_result['TRANSFERSTATUS'];
					if ($external_res === null || $mode === 'rollback')
						$_SESSION['transfer_result_code'] = -9999;
				}
			}

		}

		//get updated account info
		$transfer_dest_acc = is_numeric($_POST['transfer_dest_pot_acc']) ? $_POST['transfer_dest_pot_acc'] : null;
		$transfer_dest_number = is_numeric($_POST['transfer_dest_pot_number']) ? $_POST['transfer_dest_pot_number'] : null;
		$transfer_dest_dogovor = is_numeric($_POST['transfer_dest_pot_dogovor']) ? $_POST['transfer_dest_pot_dogovor'] : null;
		$tc_result = $conn_potok->getAccountInfo($transfer_dest_acc, $transfer_dest_number, $transfer_dest_dogovor);
		if (is_array($tc_result)) {
			$_SESSION['transfer_data_avail'] = true;
			$_SESSION['transfer_data'] = $tc_result;
		}

		header("Location: ".$session->referrer);
	}

	function procCasesOperation($caseop) {
		global $form, $stk_database, $session, $logger;

		$logger->log("procCasesOperation($caseop):".print_r($_POST, true));

		$after_case_new_ok = false;
		switch ($caseop) {
			case 'case_cardalloc':
				$res = $stk_database->allocCaseCard($session->stk_case_login,
					$_POST['case_cardalloc_method'], $_POST['case_cardalloc_allowblocked'], $_POST['case_cardalloc_days']);

				switch ($res) {
					case -3:
						$form->setError('case_cardalloc_method', "* - .");
						break;
				}

				break;
			case 'case_cardadd':
				if (strlen(trim($_POST['case_cardadd_cardid'])) == 0 || strlen(trim($_POST['case_cardadd_casepsw'])) == 0) {
					$form->setError('case_cardadd_cardid', "* !       .");
					break;
				}

				$res = $stk_database->addCaseCard($session->stk_case_login,
					$_POST['case_cardadd_casepsw'], $_POST['case_cardadd_cardid'], $_POST['case_cardadd_cardcmnt']);
				switch ($res) {
					case -60:
						$form->setError('case_cardadd_cardid', "*  !     .");
						break;
					case -105:
						$form->setError('case_cardadd_cardid', "* !    -    .");
						break;
					case -40:
						$form->setError('case_cardadd_cardid', "*   !     -     .");
						break;
					case -50:
						$form->setError('case_cardadd_cardid', "*   !    -      .");
						break;
					case 0:
					case 1:
						/*01032013 - Ivan (in DB that is ERROR)
					case -1:
					case -2:
					case -3:
					case -14:
						*/
						//OK!
						break;
					case null:
						$form->setError('case_cardadd_cardid', "  .  -.");
						break;
					default:
						$form->setError('case_cardadd_cardid', "   ($res).  -.");
				}

				break;
			case 'case_carddel':
				if (strlen(trim($_POST['case_carddel_cardid'])) == 0 || strlen(trim($_POST['case_carddel_casepsw'])) == 0) {
					$form->setError('case_carddel_cardid', "* !       .");
					break;
				}

				$res = $stk_database->delCaseCard($session->stk_case_login,
					$_POST['case_carddel_casepsw'], $_POST['case_carddel_cardid']);

				break;
			case 'case_new':
				if (strlen(trim($_POST['case_login_new'])) == 0 || strlen(trim($_POST['case_pass_new'])) == 0 || strlen(trim($_POST['case_pass_new2'])) == 0) {
					$form->setError('case_login_new', "* !       .");
					break;
				}
				if ($_POST['case_pass_new'] != $_POST['case_pass_new2']) {
					$form->setError('case_login_new', "* !     .");
					break;
				}

				/*$res = $stk_database->getQueryResultAsArray("select caseid_login from tbclientcase"
					. " where caseid_login='{$_POST['case_login_new']}'");
				if ($res) {
					$form->setError('case_login_new', "* !       .");
					break;
				}*/

				$_POST['case_type_new'] = 1;
				$res = $stk_database->getQueryResultAsArray("select * from add_client_case("
					. "'{$_POST['case_login_new']}', {$_POST['case_type_new']}, "
					. "'{$_POST['case_pass_new']}', "
					. "'{$session->stk_pin}', "
					. "'{$_POST['case_addinfo_new']}')");
				$res = is_array($res) ? $res[0]['FLAGSOUT'] : null;
				switch ($res) {
					case -105:
						$form->setError('case_login_new', "* !       .");
						break;
					case -50:
						$form->setError('case_login_new', "* !       .");
						break;
					case 0:
					case -1:
					case -2:
					case -3:
					case -14:
						//ToDo: comment the following line to enable automatic 'case_open' action
						//$form->setError('case_login_new', "OK!   !");
						$after_case_new_ok = true;
						$_POST['case_login'] = $_POST['case_login_new'];
						$_POST['case_pass'] = $_POST['case_pass_new'];
						break;
					case null:
						$form->setError('case_login_new', "    .  -.");
						break;
					default:
						//$stk_database->getStatusInfo($res)
						$form->setError('case_login_new', "     ($res).  -.");
				}

				if (!$after_case_new_ok)
					break;
			case 'case_open':
				if (!$after_case_new_ok &&
					(strlen(trim($_POST['case_login'])) == 0 || strlen(trim($_POST['case_pass'])) == 0)) {
					$form->setError('case_login', "* !       .");
					break;
				}

				$res = $stk_database->getQueryResultAsArray("select caseid_login from tbclientcase"
					. " where caseid_login='{$_POST['case_login']}' and pwd='{$_POST['case_pass']}'");
				if (!$res) {
					$form->setError('case_login', "*  !   ()   .");
					break;
				}

				//ToDo: Actual Login
				//$form->setError('case_login', "OK!    !");
				$_SESSION['stk_case_login'] = $_POST['case_login'];

				break;
			case 'case_close':
				$_SESSION['stk_case_login'] = '';
				break;
		}

		if ($form->num_errors > 0) {
			$_SESSION['value_array'] = $_POST;
			$_SESSION['error_array'] = $form->getErrorArray();
		}

		header("Location: ".$session->referrer);
	}

	/**
	 * procReports
	 */
	function procReports($sub_reports) {
		global $session, $form, $logger;

		$logger->log("procReports($sub_reports).POST=".print_r($_POST, true));

		/* edit attempt */
		$retval = true;

		if ($sub_reports == 'filter') {
			//$dt = date_parse_from_format('d.m.Y', $_POST['sf_startdate']);
			$dt = strnatcmp(phpversion(), '5.3.0') >= 0 ?
				date_parse_from_format('d.m.Y', $_POST['sf_startdate']) : date_parse($_POST['sf_startdate']);
			if ($dt['error_count'] == 0)
				$session->sf_startdate = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);

			//$dt = date_parse_from_format('d.m.Y', $_POST['sf_enddate']);
			$dt = strnatcmp(phpversion(), '5.3.0') >= 0 ?
				date_parse_from_format('d.m.Y', $_POST['sf_enddate']) : date_parse($_POST['sf_enddate']);
			if ($dt['error_count'] == 0)
				$session->sf_enddate = sprintf("%02d.%02d.%04d", $dt['day'], $dt['month'], $dt['year']);
		}

		if ($retval) {
			$session->sub_stk_reports = true;
		}
		else {
			$session->value_array = $_POST;
			$session->error_array = $form->getErrorArray();
		}
		header("Location: ".$session->referrer);
	}

};

$process = new Process;

?>
